import pygame
from pygame.locals import *
import pygame.gfxdraw
import time
pygame.mixer.init()

red = (255,0,0)
loc_snare  = (350,640)
loc_cymbal1 = (600,230)
loc_cymbal2 = (870,230)
loc_tom1 = (600,440)
loc_tom2 = (870,440)
loc_flrtom  = (1110,635)
loc_bassdrum = (735,610)
loc_hihat1 = (400,350)
loc_hihat2 = (1070,350)

BG = pygame.display.set_mode((1280,800), pygame.HWSURFACE)
img_bg = pygame.image.load("bg.png").convert()


class App:
    snare = pygame.mixer.Sound('snare.wav')
    tom1 = pygame.mixer.Sound('tom1.wav')
    tom2 = pygame.mixer.Sound('tom2.wav')
    cymbal1 = pygame.mixer.Sound('cymbal1.wav')
    cymbal2 = pygame.mixer.Sound('cymbal2.wav') 
    flrtom = pygame.mixer.Sound('flrtom.wav')
    hihat1 = pygame.mixer.Sound('hihat1.wav')
    hihat2 = pygame.mixer.Sound('hihat2.wav')
    bassdrum = pygame.mixer.Sound('bassdrum.wav')

    def __init__(self):
        self._running = True
        self._display_surf = None
        self._image_surf = None 
        
        
    def on_init(self):
        pygame.init()
        self._display_surf = BG  #frame
        self._running = True
        self._image_surf = img_bg

###################################################################
#####----- EVENT ZONE --------##############  
    def on_event(self, event):
        if event.type == QUIT:
            self._running = False

    def checkKeypad(self, event):
        if event.type == pygame.KEYDOWN:          
            if event.key == pygame.K_w:
                print('Cymbal1')
                self.onCymbal1() 
            elif event.key == pygame.K_s:
                print('Snare')
                self.onSnare()  
            elif event.key == pygame.K_a:
                print('Hihat1')
                self.onHihat1()  
            elif event.key == pygame.K_d:
                print('Tom1')
                self.onTom1() 
            elif event.key == pygame.K_j:
                print('Tom2')
                self.onTom2()  
            elif event.key == pygame.K_k:
                print('FloorTom')
                self.onFlrtom() 
            elif event.key == pygame.K_l:
                print('Hihat2')
                self.onHihat2()  
            elif event.key == pygame.K_i:
                print('Cymbal2')
                self.onCymbal2()  
            elif event.key == pygame.K_b:
                print('Bassdrum')
                self.onBassdrum()  
        #time.sleep(0.001) 
        pygame.display.flip()

    def onSnare(self):
        pygame.mixer.Sound.play(self.snare)
        # pygame.draw.circle(self._display_surf, red, loc_snare ,20 , 20)
        
    def onHihat1(self):
        pygame.mixer.Sound.play(self.hihat1)
        # pygame.draw.circle(self._display_surf, red, loc_hihat1 ,20 , 20)
        
    def onHihat2(self):
        pygame.mixer.Sound.play(self.hihat2)
        # pygame.draw.circle(self._display_surf, red, loc_hihat2 ,20 , 20)
        
    def onTom1(self):
        pygame.mixer.Sound.play(self.tom1)
        # pygame.draw.circle(self._display_surf, red, loc_tom1 ,20 , 20)
        
    def onTom2(self):
        pygame.mixer.Sound.play(self.tom2)
        # pygame.draw.circle(self._display_surf, red, loc_tom2 ,20 , 20)
        
    def onCymbal1(self):
        pygame.mixer.Sound.play(self.cymbal1)
        # pygame.draw.circle(self._display_surf, red, loc_cymbal1 ,20 , 20)
        
    def onCymbal2(self):
        pygame.mixer.Sound.play(self.cymbal2)
        # pygame.draw.circle(self._display_surf, red, loc_cymbal2 ,20 , 20)
        
    def onBassdrum(self):
        pygame.mixer.Sound.play(self.bassdrum)
        # pygame.draw.circle(self._display_surf, red, loc_bassdrum ,20 , 20)
        
    def onFlrtom(self):
        pygame.mixer.Sound.play(self.flrtom)
        # pygame.draw.circle(self._display_surf, red, loc_flrtom ,20 , 20)
        

    def fillBG(self):
        self._display_surf.blit(self._image_surf,(0,0))

    def on_render(self):
        self.fillBG()  
        pygame.display.flip()
 
    def on_cleanup(self):
        pygame.quit()
 
    def on_execute(self):
        if self.on_init() == False:
           self._running = False
        
 	while( self._running ):
            self.on_render()
            for event in pygame.event.get():
                self.on_event(event)
		self.checkKeypad(event)             
        self.on_cleanup()
        
if __name__ == "__main__" :
    theApp = App()
    theApp.on_execute()

