/*                 
 *                 BUTTON VIEW
 *        |PB1|                   |PC0|            
 * |PB5|         |PB2|     |PC5|         |PC2|
 *        |PB3|       |PB4|       |PC4|
*/

#include <usbdrv.h>
#define RQ_GET_SWITCH 1
#define numPB 5
#define numPC 4

static uint8_t B_states = 0;
static uint8_t C_states = 0;

/********** MINOR_STATES *********/
  static uint8_t PB1_state = 0;
  static uint8_t PB2_state = 0;
  static uint8_t PB3_state = 0;
  static uint8_t PB4_state = 0;
  static uint8_t PB5_state = 0;

  static uint8_t PC0_state = 0;
  static uint8_t PC2_state = 0;
  static uint8_t PC4_state = 0;
  static uint8_t PC5_state = 0; 
 
//////////////////////////////////////////////////////////////////////
usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
  usbRequest_t *rq = (usbRequest_t*)data;  

//  static uint8_t MINOR_B[2][5] = {
//    {PIN_PB1,PIN_PB2,PIN_PB3,PIN_PB4,PIN_PB5},
//    {PB1_state,PB2_state,PB3_state,PB4_state,PB5_state}
//  };
//
//  static uint8_t MINOR_C[2][4] = {
//    {PIN_PC0,PIN_PC2,PIN_PC4,PIN_PC5},
//    {PC0_state,PC2_state,PC4_state,PC5_state}
//  };
  
/********** MAJOR_STATES *********/ 

  static uint8_t MAJOR_STATES[2];
  
/*********************************/  
  if (rq->bRequest == RQ_GET_SWITCH)
  {    
      /* PIN_PB */
      if(digitalRead(PIN_PB1) == LOW) B_states |= 1 << 4;
      else B_states &= ~(1 << 4);
      if(digitalRead(PIN_PB2) == LOW) B_states |= 1 << 3;
      else B_states &= ~(1 << 3);
      if(digitalRead(PIN_PB3) == LOW) B_states |= 1 << 2;
      else B_states &= ~(1 << 2);
      if(digitalRead(PIN_PB4) == LOW) B_states |= 1 << 1;
      else B_states &= ~(1 << 1);
      if(digitalRead(PIN_PB5) == LOW) B_states |= 1 << 0;
      else B_states &= ~(1 << 0);
//      for(uint8_t i=0;i<numPB;i++){
//        if(digitalRead(MINOR_B[0][i]) == LOW && MINOR_B[1][i] == 0){
//          B_states |= 1 << numPB-(1+i);
//          MINOR_B[1][i] = 1;  
//        }else{
//          B_states &= ~(1 << numPB-(1+i));
//          if(digitalRead(MINOR_B[0][i]) == HIGH)  MINOR_B[1][i] == 0;
//        }
//      }
//      if(digitalRead(PIN_PB1) == LOW && PB1_state == 0){
//        B_states |= 1 << 4;
//        PB1_state = 1;
//      }else{
//        if(digitalRead(PIN_PB1) == HIGH)  PB1_state == 0;
//        B_states &= ~(1 << 4);        
//      }
//      if(digitalRead(PIN_PB2) == LOW && PB2_state == 0){
//        B_states |= 1 << 3;
//        PB2_state = 1;
//      }else{
//        B_states &= ~(1 << 3);
//        if(digitalRead(PIN_PB2) == HIGH)  PB2_state == 0;
//      }
//      if(digitalRead(PIN_PB3) == LOW && PB3_state == 0){
//        B_states |= 1 << 2;
//        PB3_state = 1;
//      }else{
//        B_states &= ~(1 << 2);
//        if(digitalRead(PIN_PB3) == HIGH)  PB3_state == 0;
//      }
//      if(digitalRead(PIN_PB4) == LOW && PB4_state == 0){
//        B_states |= 1 << 1;
//        PB4_state = 1;
//      }else{
//        B_states &= ~(1 << 1);
//        if(digitalRead(PIN_PB4) == HIGH)  PB4_state == 0;
//      }
//      if(digitalRead(PIN_PB5) == LOW && PB5_state == 0){
//        B_states |= 1;
//        PB5_state = 1;
//      }else{
//        B_states &= 0b11111110;
//        if(digitalRead(PIN_PB5) == HIGH)  PB5_state == 0;
//      } 
      MAJOR_STATES[0] = B_states; // send left-side states
      
      /* PIN_PC */
//      for(uint8_t i=0;i<numPC;i++){
//        if(digitalRead(MINOR_C[0][i]) == LOW && MINOR_C[1][i] == 0){
//          C_states |= 1 << numPC-(1+i);
//          MINOR_C[1][i] = 1;  
//        }else{
//          C_states &= ~(1 << numPC-(1+i));
//          if(digitalRead(MINOR_C[0][i]) == HIGH)  MINOR_C[1][i] == 0;
//        }
//      }
//      if(digitalRead(PIN_PC2) == LOW && PC2_state == 0){
//        C_states |= 1 << 3;
//        PC2_state = 1;
//      }else{
//        C_states &= ~(1 << 3);
//        if(digitalRead(PIN_PC2) == HIGH)  PC2_state == 0;
//      }
//      if(digitalRead(PIN_PC4) == LOW && PC4_state == 0){
//        C_states |= 1 << 2;
//        PC4_state = 1;
//      }else{
//        C_states &= ~(1 << 2);
//        if(digitalRead(PIN_PC4) == HIGH)  PC4_state == 0;
//      }
//      if(digitalRead(PIN_PC5) == LOW && PC5_state == 0){
//        C_states |= 1 << 1;
//        PC5_state = 1;
//      }else{
//        C_states &= ~(1 << 1);
//        if(digitalRead(PIN_PC5) == HIGH)  PC5_state == 0;
//      }
//      if(digitalRead(PIN_PC0) == LOW && PC0_state == 0){
//        C_states |= 1;
//        PC0_state = 1;
//      }else{
//        C_states &= 0b11111110;
//        if(digitalRead(PIN_PC0) == HIGH)  PC0_state == 0;
//      }     
      if(digitalRead(PIN_PC0) == LOW) C_states |= 1 << 3;
      else C_states &= ~(1 << 3);
      if(digitalRead(PIN_PC2) == LOW) C_states |= 1 << 2;
      else C_states &= ~(1 << 2);
      if(digitalRead(PIN_PC4) == LOW) C_states |= 1 << 1;
      else C_states &= ~(1 << 1);
      if(digitalRead(PIN_PC5) == LOW) C_states |= 1 << 0;
      else C_states &= ~(1 << 0);      
      MAJOR_STATES[1] = C_states; // send right-side states      
      
      usbMsgPtr = (uint8_t*) &MAJOR_STATES;
      return sizeof(MAJOR_STATES);
  }  
  return 0;   /* nothing to do; return no data back to host */
}

//////////////////////////////////////////////////////////////////////
void setup()
{
    pinMode(PIN_PB1,INPUT_PULLUP);
    pinMode(PIN_PB2,INPUT_PULLUP);
    pinMode(PIN_PB3,INPUT_PULLUP);
    pinMode(PIN_PB4,INPUT_PULLUP);
    pinMode(PIN_PB5,INPUT_PULLUP);

    pinMode(PIN_PC0,INPUT_PULLUP);
    pinMode(PIN_PC2,INPUT_PULLUP);
    pinMode(PIN_PC4,INPUT_PULLUP);
    pinMode(PIN_PC5,INPUT_PULLUP);

    Serial.begin(9600);
    
    usbInit();

    /* enforce re-enumeration of USB devices */
    usbDeviceDisconnect();
    delay(300);
    usbDeviceConnect();
}

//////////////////////////////////////////////////////////////////////
void loop()
{
  Serial.print(B_states);
  Serial.print(", ");
  Serial.println(C_states);
  usbPoll();
  
}
